/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([], function () {
    var VIEWS = {
        NAME:     "service-template-name",
        LIMITS:   "service-template-limits"
    };
    var wizardSteps = [
        {viewId: VIEWS.NAME,   text: _("Set Template Name/Type"), active: true },
        {viewId: VIEWS.LIMITS, text: _("Set Resource Limits"), active: false}
    ];

    function getWizardControlView(activeView) {
        if (activeView !== undefined) {
            for (var i = 0; i < wizardSteps.length; ++i){
                if (wizardSteps[i].viewId === activeView) {
                    wizardSteps[i].active = true;
                    wizardSteps[0].active = false;
                    break;
                }
            }
        }

        return ["aps/WizardControl",{
            steps: wizardSteps
        }];
    }

    return {
        VIEWS: VIEWS,
        getWizardControlView: getWizardControlView
    };
});
