<?php
/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

use Acronis\Cloud\Client\Model\Common\Types\Role;

class Model_PropertyConverters_ServiceRolesConverter
{
    /** @noinspection PhpDocMissingThrowsInspection */
    /**
     * @param $userResource $user
     * @param bool $isBackupApplicationEnabledForTenant
     * @return string[]
     */
    public static function getRoles($userResource, $isBackupApplicationEnabledForTenant = true)
    {
        $oldBackupPrivileges = Arr::get($userResource, 'privileged', 0);
        $tenantType = Arr::getNestedItem($userResource, ['tenant', 'type'], tenant::TYPE_CUSTOMER);
        $defaultRoles = $isBackupApplicationEnabledForTenant ? [Role::BACKUP_USER] : [];

        if ($oldBackupPrivileges === users::ADMINISTRATOR_PRIVILEGES_NO) {
            return $defaultRoles;
        } else if ($tenantType == tenant::TYPE_CUSTOMER) {
            return array_merge($defaultRoles, [Role::COMPANY_ADMIN]);
        }

        return [Role::PARTNER_ADMIN];
    }
}