<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Model_ScreenNotification_TransportInterface
{

    /**
     * Send a notification
     *
     * @param Model_ScreenNotification_Struct_MessageInterface $message
     * @return Model_ScreenNotification_Struct_MessageInterface
     * @throw Exception
     */
    public function send(Model_ScreenNotification_Struct_MessageInterface $message);

    /**
     * Update a notification
     *
     * @param string $notificationId
     * @param Model_ScreenNotification_Struct_MessageInterface $message
     *
     * @return Model_ScreenNotification_Struct_MessageInterface
     * @throw Exception
     */
    public function edit($notificationId, Model_ScreenNotification_Struct_MessageInterface $message);

    /**
     * Delete a notification
     *
     * @param string $notificationId
     *
     * @return string
     * @throw Exception
     */
    public function delete($notificationId);
}