<?php
/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

use Acronis\Cloud\Client\Model\Users\UserPost;

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Model_UserManagerInterface
{
    /**
     * @param $login
     * @param string $password
     * @return
     * @internal param string $email
     */
    public function activateUser($login, $password);

    /**
     * @param string $email
     * @param string $password
     * @throws Exception
     */
    public function resetUserPassword($email, $password);

    /**
     * @param int $userId
     * @param int $version
     * @return int
     */
    public function enableUser($userId, $version);

    /**
     * @param int $userId
     * @param int $version
     * @return int
     */
    public function disableUser($userId, $version);

    /**
     * @param int $groupId
     * @return array
     */
    public function getBackItems($groupId);

    /**
     * @param string $email
     * @param int $groupId
     * @return NULL|Service_MspApiClient_Response_Struct_UserInfo
     */
    public function getUserByEmail($email, $groupId);

    /**
     * @param $userId
     * @param bool $force
     * @return Service_MspApiClient_Response_Struct_UserInfo
     */
    public function getUserById($userId, $force = false);

    /**
     * todo remove this w/a after fix of ci-lib-php-cloud-client (array of one element => single string)
     * @param $user
     * @return string
     */
    public function getUserPersonalTenantId($user);

    /**
     * @param string $companyName
     * @return NULL|Service_MspApiClient_Response_Struct_GroupInfo
     */
    public function getGroupByName($companyName);

    /**
     * add administrator account to baas with data from PA staff member
     *
     * @param int $mspGroupId
     * @param int $subscriptionId
     * @param UserPost $userInfo
     * @throws Exception
     */
    public function provisionAdministratorAccount($mspGroupId, $subscriptionId, UserPost $userInfo);

    /**
     * @param $user
     * @param string $applicationType
     * @throws \Acronis\Cloud\Client\ApiException
     * @throws \Acronis\Cloud\Client\HttpException
     */
    public function updateUserPersonalQuotas($user, $applicationType);
}
