<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

/**
 * To make this request, be sure, you've set API base url to '',
 * because it calls api/1 method
 * Class Service_AmsApiClient_Request_Login
 */
class Service_AmsApiClient_Request_Login extends Service_BaseClient_Request_Json
{
    const REQUEST_URL = '/api/1/login?jwt=%s';

    /**
     * @param Service_BaseClient_Request_Struct_IArrayRepresentation $requestObject
     */
    public function __construct($token)
    {
        $this->_resource = Str::format(
            static::REQUEST_URL,
            $token
        );
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_AmsApiClient_Response_Login
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_AmsApiClient_Response_Login($responseBody);
    }
}
