<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Service_BaseClient_IRestClient
{
    public function refresh();

    /**
     * @param Service_BaseClient_Request_IRequest $request
     * @param string $additionalHeaders
     * @return Service_BaseClient_Response_IResponse
     */
    public function execute(Service_BaseClient_Request_IRequest $request, $additionalHeaders = NULL);

    /**
     * @param string $apiUri
     */
    public function setApiUri($apiUri);

    /**
     * @return string
     */
    public function getApiUri();

    /**
     * @param string $cookieFile
     */
    public function setCookieFile($cookieFile);

    /**
     * @return bool
     */
    public function hasCookieFile();

    public function invalidateCookies();

    /**
     * @param bool $verifySsl
     */
    public function setVerifySsl($verifySsl);
}
