<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_GetGroupsUuids extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/groups/%s/children?request_type=uuids_list';

    /**
     * @param int $parentGroupId
     */
    public function __construct($parentGroupId)
    {
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $parentGroupId);
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return string[]
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_GetGroupsUuids($responseBody);
    }
}