<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_PostMailActivate extends Service_BaseClient_Request_Json
{
    const REQUEST_URL_FORMAT = '/actions/mail/activate';

    const HTTP_CODE_SUCCESS = 204;
    const FORMAT_UNDEFINED_RESPONSE = 'Undefined response code (%s) with body: %s';

    /**
     * @param Service_MspApiClient_Request_Struct_PostMailActivateInterface $requestObject
     */
    public function __construct(Service_MspApiClient_Request_Struct_PostMailActivateInterface $requestObject)
    {
        $this->_requestObject = $requestObject;
        $this->_resource = self::REQUEST_URL_FORMAT;
        $this->_method = self::METHOD_POST;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Empty
     * @throws Exception
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        if (self::HTTP_CODE_SUCCESS === $httpCode)
        {
            return new Service_MspApiClient_Response_Empty($responseBody);
        }

        throw new Exception(sprintf(self::FORMAT_UNDEFINED_RESPONSE, $httpCode, $responseBody));
    }
}