<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_CreateNewAdministrator extends Service_BaseClient_Response_Base
{
    const PROPERTY_ID = 'id';
    const PROPERTY_UUID = 'uuid';
    const PROPERTY_VERSION = 'version';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_CreateGroup
     */
    protected function _init(array $responseData)
    {
        $createGroup = $this->_factory->getCreateGroup();
        $createGroup->setId($responseData[self::PROPERTY_ID]);
        $createGroup->setUuid($responseData[self::PROPERTY_UUID]);
        $createGroup->setVersion($responseData[self::PROPERTY_VERSION]);
        return $createGroup;
    }
}