<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Response_GetBrand extends Service_BaseClient_Response_Base
{
    const PROPERTY_ACCOUNT_SERVER_URL = 'account_server_url';
    const PROPERTY_USER_GUIDE_URL = 'user_guide_url';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_Brand
     */
    protected function _init(array $responseData)
    {
        $brand = new Service_MspApiClient_Response_Struct_Brand();
        $brand->setAccountServerUrl($this->_getProperty(self::PROPERTY_ACCOUNT_SERVER_URL, $responseData));
        $brand->setUserGuideUrl($this->_getProperty(self::PROPERTY_USER_GUIDE_URL, $responseData));
        return $brand;
    }
}