<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_GetUserById extends Service_BaseClient_Response_Base
{
    const EXCEPTION_EMPTY_RESPONSE = 'User not found';

    const PROPERTY_ID = 'id';
    const PROPERTY_UUID = 'uuid';
    const PROPERTY_USER_ID = 'user_id';
    const PROPERTY_GROUP = 'group';
    const PROPERTY_PHONE = 'phone';
    const PROPERTY_NOTIFICATIONS_BACKUP = 'notifications_backup';
    const PROPERTY_COUNTRY = 'country';
    const PROPERTY_STATUS = 'status';
    const PROPERTY_CITY = 'city';
    const PROPERTY_FIRSTNAME = 'firstname';
    const PROPERTY_LASTNAME = 'lastname';
    const PROPERTY_USAGE = 'usage';
    const PROPERTY_VM_COUNT = 'vm_count';
    const PROPERTY_SERVER_COUNT = 'server_count';
    const PROPERTY_WORKSTATION_COUNT = 'workstation_count';
    const PROPERTY_MOBILE_COUNT = 'mobile_count';
    const PROPERTY_MAILBOX_COUNT = 'mailbox_count';



















































































































// scripts_app_service_msp_api_client_response_get_user_by_id_constant this code is used for code generation, do not remove!
    const PROPERTY_WEB_HOSTING_SERVER_COUNT = 'web_hosting_server_count';
    const PROPERTY_WEBSITE_COUNT = 'website_count';
    const PROPERTY_STORAGE_SIZE = 'storage_size';
    const PROPERTY_LOCAL_STORAGE_SIZE = 'local_storage_size';
    const PROPERTY_ZIPCODE = 'zipcode';
    const PROPERTY_NOTIFICATIONS_MANAGEMENT = 'notifications_management';
    const PROPERTY_STATE = 'state';
    const PROPERTY_PRIVILEGES = 'privileges';
    const PROPERTY_EMAIL = 'email';
    const PROPERTY_ADDRESS_1 = 'address1';
    const PROPERTY_ADDRESS_2 = 'address2';
    const PROPERTY_VERSION = 'version';
    const PROPERTY_LOGIN = 'login';
    const PROPERTY_PRIVILEGED = 'privileged';

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_UserInfo
     * @throws Exception
     */
    protected function _init(array $responseData)
    {
        $userInfo = new Service_MspApiClient_Response_Struct_UserInfo();
        if (empty($responseData)) {
            throw new Exception(self::EXCEPTION_EMPTY_RESPONSE);
        }
        
        $userInfo->setId($this->_getProperty(self::PROPERTY_ID, $responseData));
        $userInfo->setUuid($this->_getProperty(self::PROPERTY_UUID, $responseData));
        $userInfo->setUserId($this->_getProperty(self::PROPERTY_USER_ID, $responseData));
        $userInfo->setGroup($this->_getProperty(self::PROPERTY_GROUP, $responseData));
        $userInfo->setPhone($this->_getProperty(self::PROPERTY_PHONE, $responseData));
        $userInfo->setNotificationsBackup($this->_getProperty(self::PROPERTY_NOTIFICATIONS_BACKUP, $responseData));
        $userInfo->setCountry($this->_getProperty(self::PROPERTY_COUNTRY, $responseData));
        $userInfo->setStatus($this->_getProperty(self::PROPERTY_STATUS, $responseData));
        $userInfo->setCity($this->_getProperty(self::PROPERTY_CITY, $responseData));
        $userInfo->setFirstName($this->_getProperty(self::PROPERTY_FIRSTNAME, $responseData));
        $userInfo->setLastName($this->_getProperty(self::PROPERTY_LASTNAME, $responseData));
        $userInfo->setZipCode($this->_getProperty(self::PROPERTY_ZIPCODE, $responseData));
        $userInfo->setNotificationsManagement($this->_getProperty(self::PROPERTY_NOTIFICATIONS_MANAGEMENT, $responseData));
        $userInfo->setState($this->_getProperty(self::PROPERTY_STATE, $responseData));
        $userInfo->setEmail($this->_getProperty(self::PROPERTY_EMAIL, $responseData));
        $userInfo->setAddress1($this->_getProperty(self::PROPERTY_ADDRESS_1, $responseData));
        $userInfo->setAddress2($this->_getProperty(self::PROPERTY_ADDRESS_2, $responseData));
        $userInfo->setVersion($this->_getProperty(self::PROPERTY_VERSION, $responseData));
        $userInfo->setLogin($this->_getProperty(self::PROPERTY_LOGIN, $responseData));
        $userInfo->setPrivileged($this->_getProperty(self::PROPERTY_PRIVILEGED, $responseData));

        $usageData = $this->_getProperty(self::PROPERTY_USAGE, $responseData);
        $usage = $userInfo->getUsage();
        $usage->setVmCount($this->_getProperty(self::PROPERTY_VM_COUNT, $usageData));
        $usage->setServerCount($this->_getProperty(self::PROPERTY_SERVER_COUNT, $usageData));
        $usage->setWorkstationCount($this->_getProperty(self::PROPERTY_WORKSTATION_COUNT, $usageData));
        $usage->setMobileCount($this->_getProperty(self::PROPERTY_MOBILE_COUNT, $usageData, false));
        $usage->setMailboxCount($this->_getProperty(self::PROPERTY_MAILBOX_COUNT, $usageData, false));



















































































































// scripts_app_service_msp_api_client_response_get_user_by_id_set_usage this code is used for code generation, do not remove!
        $usage->setWebHostingServerCount($this->_getProperty(self::PROPERTY_WEB_HOSTING_SERVER_COUNT, $usageData, false));
        $usage->setWebsiteCount($this->_getProperty(self::PROPERTY_WEBSITE_COUNT, $usageData, false));
        $usage->setStorageSize($this->_getProperty(self::PROPERTY_STORAGE_SIZE, $usageData));
        $usage->setLocalStorageSize($this->_getProperty(self::PROPERTY_LOCAL_STORAGE_SIZE, $usageData, false));

        $privilegesData = $this->_getProperty(self::PROPERTY_PRIVILEGES, $responseData);
        $privileges = $userInfo->getPrivileges();
        $privileges->setVmCount($this->_getProperty(self::PROPERTY_VM_COUNT, $privilegesData));
        $privileges->setServerCount($this->_getProperty(self::PROPERTY_SERVER_COUNT, $privilegesData));
        $privileges->setWorkstationCount($this->_getProperty(self::PROPERTY_WORKSTATION_COUNT, $privilegesData));
        $privileges->setMobileCount($this->_getProperty(self::PROPERTY_MOBILE_COUNT, $privilegesData, false));
        $privileges->setMailboxCount($this->_getProperty(self::PROPERTY_MAILBOX_COUNT, $privilegesData, false));



















































































































// scripts_app_service_msp_api_client_response_get_user_by_id_set_privileges this code is used for code generation, do not remove!
        $privileges->setWebHostingServerCount($this->_getProperty(self::PROPERTY_WEB_HOSTING_SERVER_COUNT, $privilegesData, false));
        $privileges->setWebsiteCount($this->_getProperty(self::PROPERTY_WEBSITE_COUNT, $privilegesData, false));
        $privileges->setStorageSize($this->_getProperty(self::PROPERTY_STORAGE_SIZE, $privilegesData));
        $privileges->setLocalStorageSize($this->_getProperty(self::PROPERTY_LOCAL_STORAGE_SIZE, $privilegesData, false));

        return $userInfo;
    }
}



