<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_CreateManualOrder extends Service_PbaApi_Client_Request
{
    const METHOD = 'CreateManualOrder_API';

    /**
     * Service_PbaApi_Api_Request_CreateManualOrder constructor.
     * @param Service_PbaApi_Api_Request_Struct_OrderAttributes $orderAttributes
     * @param Service_PbaApi_Api_Request_Struct_OrderDetailAttributes[] $orderDetails
     * @param Service_PbaApi_Api_Request_Struct_TaxDetailAttributes[] $taxDetails
     */
    public function __construct(Service_PbaApi_Api_Request_Struct_OrderAttributes $orderAttributes, array $orderDetails, array $taxDetails = array())
    {
        $parameters = array();
        $parameters[] = (string) $orderAttributes;
        foreach ($orderDetails as $orderDetail) {
            $parameters[] = (string) $orderDetail;
        }
        foreach ($taxDetails as $taxDetail) {
            $parameters[] = (string) $taxDetail;
        }
        parent::__construct(self::METHOD, $parameters);
    }

    /**
     * Method returns details of specified subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_CreateManualOrder
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_CreateManualOrder($responseArray);
    }
}
