<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_GetAndValidatePlanParams extends Service_PbaApi_Client_Request
{
    const METHOD = 'PlanParamsGetAndValidate_API';


    /**
     * Service_PbaApi_Api_Request_GetAndValidatePlanParams constructor.
     * @param int $planId
     * @param int $serviceTemplateID
     * @param Service_PbaApi_Api_Request_Struct_ServiceTemplateParameter[] $parameters
     */
    public function __construct($planId, $serviceTemplateID, array $parameters = array())
    {
        $requestParameters = array(
            (int)$planId,
            (int)$serviceTemplateID
        );

        foreach ($parameters as $parameter) {
            $requestParameters[] = (string) $parameter;
        }

        parent::__construct(self::METHOD, $requestParameters);
    }

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_GetAndValidatePlanParams
     */
    public function getExpectedResponse(array $responseArray = NULL)
    {
        return new Service_PbaApi_Api_Response_GetAndValidatePlanParams($responseArray);
    }
}
