<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Request_PlaceResourceUpgradeOrder extends Service_PbaApi_Client_Request
{
    const METHOD = 'PlaceResourceUpgradeOrder_API';

    /**
     * @param $subscriptionId
     * @param $usePayTool
     * @param $useDefaultPayTool
     * @param $userId
     * @param $fromIp
     * @param Service_PbaApi_Api_Request_Struct_ResourceUpgradeOrder[] $resourceUpgradeOrders
     * @return mixed
     * @throws Service_PbaApi_Api_Exception
     */
    public function __construct($subscriptionId, $usePayTool, $useDefaultPayTool, $userId, $fromIp, $resourceUpgradeOrders)
    {
        $resourceForUpgrade = array();
        foreach ($resourceUpgradeOrders as $resourceUpgradeOrder) {
            $resourceForUpgrade[] = $resourceUpgradeOrder->getResourceID();
            $resourceForUpgrade[] = $resourceUpgradeOrder->getNewResourceID();
            $resourceForUpgrade[] = $resourceUpgradeOrder->getAmount();
        }

        $parameters = array_merge(array(
            $subscriptionId, $usePayTool, $useDefaultPayTool, $userId, $fromIp,
        ), $resourceForUpgrade);
        parent::__construct(self::METHOD, $parameters);
    }

    /**
     * Method returns details of specified subscription.
     *
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_GetSubscriptionResourcesList
     */
    public function getExpectedResponse(array $responseArray = null)
    {
        return new Service_PbaApi_Api_Response_PlaceResourceUpgradeOrder($responseArray);
    }
}
