<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetAvailablePlanList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetAvailablePlanList';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_AvailablePlanListItemInterface[]
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray))
        {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach($listData as $itemData)
        {
            $item = new Service_PbaApi_Api_Response_Struct_AvailablePlanListItem();
            $item->setPlanId($this->_getProperty(0, $itemData));
            $item->setName($this->_getProperty(1, $itemData));
            $item->setShortDescription($this->_getProperty(2, $itemData));
            $item->setLongDescription($this->_getProperty(3, $itemData));
            $item->setPlanCategoryId($this->_getProperty(4, $itemData));
            $item->setStType($this->_getProperty(5, $itemData));
            $item->setIsPublished($this->_getProperty(6, $itemData));
            $item->setGroupId($this->_getProperty(7, $itemData));
            $item->setRecurringType($this->_getProperty(8, $itemData));
            $item->setBillingPeriodType($this->_getProperty(9, $itemData));
            $item->setBillingPeriod($this->_getProperty(10, $itemData));
            $item->setIsParentReq($this->_getProperty(11, $itemData));
            $item->setShowPriority($this->_getProperty(12, $itemData));
            $item->setDefaultPlanPeriodId($this->_getProperty(13, $itemData));

            $list[] = $item;
        }
        return $list;
    }
}
