<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanDetails extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_PlanDetails
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray))
        {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }
        $planDetailsData = $this->_getProperty(0, $responseArray);

        $planDetails = new Service_PbaApi_Api_Response_Struct_PlanDetails();
        $planDetails->setPlanId($this->_getProperty(0, $planDetailsData));
        $planDetails->setName($this->_getProperty(1, $planDetailsData));
        $planDetails->setCategoryId($this->_getProperty(2, $planDetailsData));
        $planDetails->setResourceCurrencyId($this->_getProperty(3, $planDetailsData));
        $planDetails->setShortDescription($this->_getProperty(4, $planDetailsData));
        $planDetails->setLongDescription($this->_getProperty(5, $planDetailsData));
        $planDetails->setGateName($this->_getProperty(6, $planDetailsData));
        $planDetails->setGroupId($this->_getProperty(7, $planDetailsData));
        $planDetails->setIsParentRequired($this->_getProperty(8, $planDetailsData));
        $planDetails->setRecurringType($this->_getProperty(9, $planDetailsData));
        $planDetails->setBillingPeriodType($this->_getProperty(10, $planDetailsData));
        $planDetails->setBillingPeriod($this->_getProperty(11, $planDetailsData));
        $planDetails->setShowPriority($this->_getProperty(12, $planDetailsData));
        $planDetails->setDefaultPlanPeriodId($this->_getProperty(13, $planDetailsData));
        $planDetails->setIsOTFI($this->_getProperty(14, $planDetailsData));
        $planDetails->setDocumentId($this->_getProperty(15, $planDetailsData));

        return $planDetails;
    }
}
