<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_PlacePlanPeriodSwitchOrder extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    /**
     * @param array|NULL $responseArray
     * @return Service_PbaApi_Api_Response_Struct_PlacePlanPeriodSwitchOrder
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray))
        {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $responseData = $this->_getProperty(0, $responseArray);
        $response = new Service_PbaApi_Api_Response_Struct_PlacePlanPeriodSwitchOrder();
        $response->setOrderId($this->_getProperty(0, $responseData));
        $response->setTotal($this->_getProperty(1, $responseData));
        $response->setTaxTotal($this->_getProperty(2, $responseData));
        $response->setDiscountTotal($this->_getProperty(3, $responseData));
        $response->setMerchTotal($this->_getProperty(4, $responseData));
        $response->setOrderNumber($this->_getProperty(5, $responseData));
        $response->setDescription($this->_getProperty(6, $responseData));
        $response->setCreationTime($this->_getProperty(7, $responseData));
        $response->setDocumentId($this->_getProperty(8, $responseData));
        return $response;
    }
}
