<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_HttpTransport_Request implements Service_PbaApi_HttpTransport_RequestInterface
{
    /** @var string */
    private $_method;

    /** @var string */
    private $_url;

    /** @var string | NULL */
    private $_data;

    /** @var string | NULL */
    private $_headers;

    /**
     * @param string $method
     * @param string $url
     * @param string | NULL $data
     * @param string | NULL $headers
     */
    public function __construct($method, $url, $data = NULL, $headers = NULL)
    {
        $this->_method = $method;
        $this->_url = $url;
        $this->_data = $data;
        $this->_headers = $headers;
    }

    /**
     * @return string
     */
    public function getMethod()
    {
        return $this->_method;
    }

    /**
     * @return string
     */
    public function getUrl()
    {
        return $this->_url;
    }

    /**
     * @return array | NULL
     */
    public function getHeaders()
    {
        return $this->_headers;
    }

    /**
     * @return string | NULL
     */
    public function getBody()
    {
        return $this->_data;
    }
}