<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface LogInterface
{
    /**
     * System is unusable.
     *
     * @param string $message
     */
    public function emergency($message);

    /**
     * Action must be taken immediately.
     *
     * @param string $message
     */
    public function alert($message);

    /**
     * Critical conditions.
     *
     * @param string $message
     */
    public function critical($message);

    /**
     * Normal but significant events.
     *
     * @param string $message
     */
    public function notice($message);

    /**
     * Interesting events.
     *
     * @param string $message
     */
    public function info($message);

    /**
     * Detailed debug information.
     *
     * @param string $message
     */
    public function debug($message);

    /**
     * Alias of method info
     *
     * @param $message
     */
    public function event($message);

    /**
     * Exceptional occurrences that are not errors.
     *
     * @param string $message
     */
    public function warning($message);

    /**
     * Runtime errors that do not require immediate action but should typically
     * be logged and monitored.
     *
     * @param string $message
     */
    public function error($message);
}