# SwaggerClient-php
No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2
- Build package: io.swagger.codegen.languages.PhpClientCodegen

## Requirements

PHP 5.4.0 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\AccessApi();
$access_policy_id = "access_policy_id_example"; // string | 
$_issues = "_issues_example"; // string | 

try {
    $api_instance->deleteAccessPoliciesByAccessPolicyId($access_policy_id, $_issues);
} catch (Exception $e) {
    echo 'Exception when calling AccessApi->deleteAccessPoliciesByAccessPolicyId: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *https://localhost:443/api/2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccessApi* | [**deleteAccessPoliciesByAccessPolicyId**](docs/Api/AccessApi.md#deleteaccesspoliciesbyaccesspolicyid) | **DELETE** /access_policies/{access_policy_id} | AccessPoliciesByAccessPolicyId
*AccessApi* | [**getAccessPolicies**](docs/Api/AccessApi.md#getaccesspolicies) | **GET** /access_policies | AccessPolicies
*AccessApi* | [**getAccessPoliciesByAccessPolicyId**](docs/Api/AccessApi.md#getaccesspoliciesbyaccesspolicyid) | **GET** /access_policies/{access_policy_id} | AccessPoliciesByAccessPolicyId
*AdApi* | [**getAd**](docs/Api/AdApi.md#getad) | **GET** /ad | Ad
*AdApi* | [**putAdSearch**](docs/Api/AdApi.md#putadsearch) | **PUT** /ad/search | AdSearch
*ApplicationsApi* | [**deleteApplicationsBindingsTenants**](docs/Api/ApplicationsApi.md#deleteapplicationsbindingstenants) | **DELETE** /applications/{application_id}/bindings/tenants/{tenant_id} | ApplicationsBindingsTenants
*ApplicationsApi* | [**deleteApplicationsSettingsTenantsSettingName**](docs/Api/ApplicationsApi.md#deleteapplicationssettingstenantssettingname) | **DELETE** /applications/{application_id}/settings/tenants/{tenant_id}/{setting_name} | ApplicationsSettingsTenantsSettingName
*ApplicationsApi* | [**deleteApplicationsSettingsUsersSettingName**](docs/Api/ApplicationsApi.md#deleteapplicationssettingsuserssettingname) | **DELETE** /applications/{application_id}/settings/users/{user_id}/{setting_name} | ApplicationsSettingsUsersSettingName
*ApplicationsApi* | [**getApplications**](docs/Api/ApplicationsApi.md#getapplications) | **GET** /applications | Applications
*ApplicationsApi* | [**getApplicationsByApplicationId**](docs/Api/ApplicationsApi.md#getapplicationsbyapplicationid) | **GET** /applications/{application_id} | ApplicationsByApplicationId
*ApplicationsApi* | [**getApplicationsResourceServers**](docs/Api/ApplicationsApi.md#getapplicationsresourceservers) | **GET** /applications/{application_id}/resource_servers | ApplicationsResourceServers
*ApplicationsApi* | [**getApplicationsSettingsSchemas**](docs/Api/ApplicationsApi.md#getapplicationssettingsschemas) | **GET** /applications/{application_id}/settings/schemas | ApplicationsSettingsSchemas
*ApplicationsApi* | [**getApplicationsSettingsTenants**](docs/Api/ApplicationsApi.md#getapplicationssettingstenants) | **GET** /applications/{application_id}/settings/tenants/{tenant_id} | ApplicationsSettingsTenants
*ApplicationsApi* | [**getApplicationsSettingsTenantsSettingName**](docs/Api/ApplicationsApi.md#getapplicationssettingstenantssettingname) | **GET** /applications/{application_id}/settings/tenants/{tenant_id}/{setting_name} | ApplicationsSettingsTenantsSettingName
*ApplicationsApi* | [**getApplicationsSettingsUsersByApplicationId**](docs/Api/ApplicationsApi.md#getapplicationssettingsusersbyapplicationid) | **GET** /applications/{application_id}/settings/users/{user_id} | ApplicationsSettingsUsersByApplicationId
*ApplicationsApi* | [**getApplicationsSettingsUsersSettingName**](docs/Api/ApplicationsApi.md#getapplicationssettingsuserssettingname) | **GET** /applications/{application_id}/settings/users/{user_id}/{setting_name} | ApplicationsSettingsUsersSettingName
*ApplicationsApi* | [**postApplicationsBindingsTenants**](docs/Api/ApplicationsApi.md#postapplicationsbindingstenants) | **POST** /applications/{application_id}/bindings/tenants/{tenant_id} | ApplicationsBindingsTenants
*ApplicationsApi* | [**putApplicationsSettingsTenantsSettingName**](docs/Api/ApplicationsApi.md#putapplicationssettingstenantssettingname) | **PUT** /applications/{application_id}/settings/tenants/{tenant_id}/{setting_name} | ApplicationsSettingsTenantsSettingName
*ApplicationsApi* | [**putApplicationsSettingsUsersSettingName**](docs/Api/ApplicationsApi.md#putapplicationssettingsuserssettingname) | **PUT** /applications/{application_id}/settings/users/{user_id}/{setting_name} | ApplicationsSettingsUsersSettingName
*BillingApi* | [**getBillingTenantsByTenantId**](docs/Api/BillingApi.md#getbillingtenantsbytenantid) | **GET** /billing/tenants/{tenant_id} | BillingTenantsByTenantId
*BillingApi* | [**getBillingTenantsPeriodsByTenantId**](docs/Api/BillingApi.md#getbillingtenantsperiodsbytenantid) | **GET** /billing/tenants/{tenant_id}/periods | BillingTenantsPeriodsByTenantId
*BillingApi* | [**putBillingTenantsByTenantId**](docs/Api/BillingApi.md#putbillingtenantsbytenantid) | **PUT** /billing/tenants/{tenant_id} | BillingTenantsByTenantId
*BillingApi* | [**putBillingTenantsPeriodsByTenantId**](docs/Api/BillingApi.md#putbillingtenantsperiodsbytenantid) | **PUT** /billing/tenants/{tenant_id}/periods | BillingTenantsPeriodsByTenantId
*ClientsApi* | [**deleteClientsByClientId**](docs/Api/ClientsApi.md#deleteclientsbyclientid) | **DELETE** /clients/{client_id} | ClientsByClientId
*ClientsApi* | [**getClientsAccessPoliciesByClientId**](docs/Api/ClientsApi.md#getclientsaccesspoliciesbyclientid) | **GET** /clients/{client_id}/access_policies | ClientsAccessPoliciesByClientId
*ClientsApi* | [**getClientsByClientId**](docs/Api/ClientsApi.md#getclientsbyclientid) | **GET** /clients/{client_id} | ClientsByClientId
*ClientsApi* | [**postClients**](docs/Api/ClientsApi.md#postclients) | **POST** /clients | Clients
*ClientsApi* | [**postClientsAccessPoliciesByClientId**](docs/Api/ClientsApi.md#postclientsaccesspoliciesbyclientid) | **POST** /clients/{client_id}/access_policies | ClientsAccessPoliciesByClientId
*ClientsApi* | [**putClientsByClientId**](docs/Api/ClientsApi.md#putclientsbyclientid) | **PUT** /clients/{client_id} | ClientsByClientId
*DefaultApi* | [**getUnnammedEndpoint**](docs/Api/DefaultApi.md#getunnammedendpoint) | **GET** / | Unnammed Endpoint
*IdpApi* | [**deleteIdpIdentitiesByIdentityId**](docs/Api/IdpApi.md#deleteidpidentitiesbyidentityid) | **DELETE** /idp/identities/{identity_id} | IdpIdentitiesByIdentityId
*IdpApi* | [**deleteIdpSessionsById**](docs/Api/IdpApi.md#deleteidpsessionsbyid) | **DELETE** /idp/sessions/{id} | IdpSessionsById
*IdpApi* | [**getIdpAuthorize**](docs/Api/IdpApi.md#getidpauthorize) | **GET** /idp/authorize | IdpAuthorize
*IdpApi* | [**getIdpIdentitiesByIdentityId**](docs/Api/IdpApi.md#getidpidentitiesbyidentityid) | **GET** /idp/identities/{identity_id} | IdpIdentitiesByIdentityId
*IdpApi* | [**getIdpKeys**](docs/Api/IdpApi.md#getidpkeys) | **GET** /idp/keys | IdpKeys
*IdpApi* | [**getIdpSessions**](docs/Api/IdpApi.md#getidpsessions) | **GET** /idp/sessions | IdpSessions
*IdpApi* | [**postIdpIdentities**](docs/Api/IdpApi.md#postidpidentities) | **POST** /idp/identities | IdpIdentities
*IdpApi* | [**postIdpPassword**](docs/Api/IdpApi.md#postidppassword) | **POST** /idp/password | IdpPassword
*IdpApi* | [**postIdpToken**](docs/Api/IdpApi.md#postidptoken) | **POST** /idp/token | IdpToken
*IdpApi* | [**putIdpIdentitiesByIdentityId**](docs/Api/IdpApi.md#putidpidentitiesbyidentityid) | **PUT** /idp/identities/{identity_id} | IdpIdentitiesByIdentityId
*IdpApi* | [**putIdpPassword**](docs/Api/IdpApi.md#putidppassword) | **PUT** /idp/password | IdpPassword
*InfraApi* | [**deleteInfraByInfraId**](docs/Api/InfraApi.md#deleteinfrabyinfraid) | **DELETE** /infra/{infra_id} | InfraByInfraId
*InfraApi* | [**getInfra**](docs/Api/InfraApi.md#getinfra) | **GET** /infra | Infra
*InfraApi* | [**getInfraByInfraId**](docs/Api/InfraApi.md#getinfrabyinfraid) | **GET** /infra/{infra_id} | InfraByInfraId
*InfraApi* | [**postInfra**](docs/Api/InfraApi.md#postinfra) | **POST** /infra | Infra
*InfraApi* | [**putInfraByInfraId**](docs/Api/InfraApi.md#putinfrabyinfraid) | **PUT** /infra/{infra_id} | InfraByInfraId
*ReportsApi* | [**deleteReportsByReportId**](docs/Api/ReportsApi.md#deletereportsbyreportid) | **DELETE** /reports/{report_id} | ReportsByReportId
*ReportsApi* | [**getReportsByReportId**](docs/Api/ReportsApi.md#getreportsbyreportid) | **GET** /reports/{report_id} | ReportsByReportId
*ReportsApi* | [**postReports**](docs/Api/ReportsApi.md#postreports) | **POST** /reports | Reports
*ReportsApi* | [**putReportsByReportId**](docs/Api/ReportsApi.md#putreportsbyreportid) | **PUT** /reports/{report_id} | ReportsByReportId
*ResourceApi* | [**getResourceServersByResourceServerId**](docs/Api/ResourceApi.md#getresourceserversbyresourceserverid) | **GET** /resource_servers/{resource_server_id} | ResourceServersByResourceServerId
*RolesApi* | [**deleteRolesByRoleId**](docs/Api/RolesApi.md#deleterolesbyroleid) | **DELETE** /roles/{role_id} | RolesByRoleId
*RolesApi* | [**getRolesByRoleId**](docs/Api/RolesApi.md#getrolesbyroleid) | **GET** /roles/{role_id} | RolesByRoleId
*RolesApi* | [**postRoles**](docs/Api/RolesApi.md#postroles) | **POST** /roles | Roles
*RolesApi* | [**putRolesByRoleId**](docs/Api/RolesApi.md#putrolesbyroleid) | **PUT** /roles/{role_id} | RolesByRoleId
*TenantsApi* | [**deleteTenantsByTenantId**](docs/Api/TenantsApi.md#deletetenantsbytenantid) | **DELETE** /tenants/{tenant_id} | TenantsByTenantId
*TenantsApi* | [**getTenants**](docs/Api/TenantsApi.md#gettenants) | **GET** /tenants | Tenants
*TenantsApi* | [**getTenantsAccessPoliciesByTenantId**](docs/Api/TenantsApi.md#gettenantsaccesspoliciesbytenantid) | **GET** /tenants/{tenant_id}/access_policies | TenantsAccessPoliciesByTenantId
*TenantsApi* | [**getTenantsApplicationsByTenantId**](docs/Api/TenantsApi.md#gettenantsapplicationsbytenantid) | **GET** /tenants/{tenant_id}/applications | TenantsApplicationsByTenantId
*TenantsApi* | [**getTenantsApplicationsOfferingItems**](docs/Api/TenantsApi.md#gettenantsapplicationsofferingitems) | **GET** /tenants/{tenant_id}/applications/{application_id}/offering_items | TenantsApplicationsOfferingItems
*TenantsApi* | [**getTenantsApplicationsRolesByTenantId**](docs/Api/TenantsApi.md#gettenantsapplicationsrolesbytenantid) | **GET** /tenants/{tenant_id}/applications/roles | TenantsApplicationsRolesByTenantId
*TenantsApi* | [**getTenantsApplicationsRolesByTenantIdAndApplicationId**](docs/Api/TenantsApi.md#gettenantsapplicationsrolesbytenantidandapplicationid) | **GET** /tenants/{tenant_id}/applications/{application_id}/roles | TenantsApplicationsRolesByTenantIdAndApplicationId
*TenantsApi* | [**getTenantsApplicationsUsagesUsageName**](docs/Api/TenantsApi.md#gettenantsapplicationsusagesusagename) | **GET** /tenants/{tenant_id}/applications/{application_id}/usages/{usage_name} | TenantsApplicationsUsagesUsageName
*TenantsApi* | [**getTenantsBrandByTenantId**](docs/Api/TenantsApi.md#gettenantsbrandbytenantid) | **GET** /tenants/{tenant_id}/brand | TenantsBrandByTenantId
*TenantsApi* | [**getTenantsBrandsByTenantId**](docs/Api/TenantsApi.md#gettenantsbrandsbytenantid) | **GET** /tenants/{tenant_id}/brands | TenantsBrandsByTenantId
*TenantsApi* | [**getTenantsByTenantId**](docs/Api/TenantsApi.md#gettenantsbytenantid) | **GET** /tenants/{tenant_id} | TenantsByTenantId
*TenantsApi* | [**getTenantsChildrenByTenantId**](docs/Api/TenantsApi.md#gettenantschildrenbytenantid) | **GET** /tenants/{tenant_id}/children | TenantsChildrenByTenantId
*TenantsApi* | [**getTenantsClientsByTenantId**](docs/Api/TenantsApi.md#gettenantsclientsbytenantid) | **GET** /tenants/{tenant_id}/clients | TenantsClientsByTenantId
*TenantsApi* | [**getTenantsInfraByTenantId**](docs/Api/TenantsApi.md#gettenantsinfrabytenantid) | **GET** /tenants/{tenant_id}/infra | TenantsInfraByTenantId
*TenantsApi* | [**getTenantsOfferingItemsByTenantId**](docs/Api/TenantsApi.md#gettenantsofferingitemsbytenantid) | **GET** /tenants/{tenant_id}/offering_items | TenantsOfferingItemsByTenantId
*TenantsApi* | [**getTenantsReportsByTenantId**](docs/Api/TenantsApi.md#gettenantsreportsbytenantid) | **GET** /tenants/{tenant_id}/reports | TenantsReportsByTenantId
*TenantsApi* | [**getTenantsRolesByTenantId**](docs/Api/TenantsApi.md#gettenantsrolesbytenantid) | **GET** /tenants/{tenant_id}/roles | TenantsRolesByTenantId
*TenantsApi* | [**getTenantsUsages**](docs/Api/TenantsApi.md#gettenantsusages) | **GET** /tenants/usages | TenantsUsages
*TenantsApi* | [**getTenantsUsagesByTenantId**](docs/Api/TenantsApi.md#gettenantsusagesbytenantid) | **GET** /tenants/{tenant_id}/usages | TenantsUsagesByTenantId
*TenantsApi* | [**getTenantsUserGroupsByTenantId**](docs/Api/TenantsApi.md#gettenantsusergroupsbytenantid) | **GET** /tenants/{tenant_id}/user_groups | TenantsUserGroupsByTenantId
*TenantsApi* | [**getTenantsUsersByTenantId**](docs/Api/TenantsApi.md#gettenantsusersbytenantid) | **GET** /tenants/{tenant_id}/users | TenantsUsersByTenantId
*TenantsApi* | [**postTenants**](docs/Api/TenantsApi.md#posttenants) | **POST** /tenants | Tenants
*TenantsApi* | [**postTenantsSearchByTenantId**](docs/Api/TenantsApi.md#posttenantssearchbytenantid) | **POST** /tenants/{tenant_id}/search | TenantsSearchByTenantId
*TenantsApi* | [**putTenantsByTenantId**](docs/Api/TenantsApi.md#puttenantsbytenantid) | **PUT** /tenants/{tenant_id} | TenantsByTenantId
*TenantsApi* | [**putTenantsOfferingItemsByTenantId**](docs/Api/TenantsApi.md#puttenantsofferingitemsbytenantid) | **PUT** /tenants/{tenant_id}/offering_items | TenantsOfferingItemsByTenantId
*UserApi* | [**deleteUserGroupsByUserGroupId**](docs/Api/UserApi.md#deleteusergroupsbyusergroupid) | **DELETE** /user_groups/{user_group_id} | UserGroupsByUserGroupId
*UserApi* | [**getUserGroupsAccessPolicies**](docs/Api/UserApi.md#getusergroupsaccesspolicies) | **GET** /user_groups/access_policies | UserGroupsAccessPolicies
*UserApi* | [**getUserGroupsAccessPoliciesByUserGroupId**](docs/Api/UserApi.md#getusergroupsaccesspoliciesbyusergroupid) | **GET** /user_groups/{user_group_id}/access_policies | UserGroupsAccessPoliciesByUserGroupId
*UserApi* | [**getUserGroupsByUserGroupId**](docs/Api/UserApi.md#getusergroupsbyusergroupid) | **GET** /user_groups/{user_group_id} | UserGroupsByUserGroupId
*UserApi* | [**postUserGroups**](docs/Api/UserApi.md#postusergroups) | **POST** /user_groups | UserGroups
*UserApi* | [**postUserGroupsAccessPolicies**](docs/Api/UserApi.md#postusergroupsaccesspolicies) | **POST** /user_groups/access_policies | UserGroupsAccessPolicies
*UserApi* | [**postUserGroupsAccessPoliciesByUserGroupId**](docs/Api/UserApi.md#postusergroupsaccesspoliciesbyusergroupid) | **POST** /user_groups/{user_group_id}/access_policies | UserGroupsAccessPoliciesByUserGroupId
*UserApi* | [**postUserGroupsChangeEmail**](docs/Api/UserApi.md#postusergroupschangeemail) | **POST** /user_groups/change_email | UserGroupsChangeEmail
*UserApi* | [**putUserGroupsAccessPolicies**](docs/Api/UserApi.md#putusergroupsaccesspolicies) | **PUT** /user_groups/access_policies | UserGroupsAccessPolicies
*UsersApi* | [**deleteUsersByUserId**](docs/Api/UsersApi.md#deleteusersbyuserid) | **DELETE** /users/{user_id} | UsersByUserId
*UsersApi* | [**deleteUsersReportSubscriptionsByUserId**](docs/Api/UsersApi.md#deleteusersreportsubscriptionsbyuserid) | **DELETE** /users/{user_id}/report-subscriptions/{report_id} | UsersReportSubscriptionsByUserId
*UsersApi* | [**getUsers**](docs/Api/UsersApi.md#getusers) | **GET** /users | Users
*UsersApi* | [**getUsersAccessPoliciesByUserId**](docs/Api/UsersApi.md#getusersaccesspoliciesbyuserid) | **GET** /users/{user_id}/access_policies | UsersAccessPoliciesByUserId
*UsersApi* | [**getUsersByUserId**](docs/Api/UsersApi.md#getusersbyuserid) | **GET** /users/{user_id} | UsersByUserId
*UsersApi* | [**getUsersCheckLogin**](docs/Api/UsersApi.md#getuserschecklogin) | **GET** /users/check_login | UsersCheckLogin
*UsersApi* | [**getUsersMe**](docs/Api/UsersApi.md#getusersme) | **GET** /users/me | UsersMe
*UsersApi* | [**getUsersReportSubscriptionsByUserId**](docs/Api/UsersApi.md#getusersreportsubscriptionsbyuserid) | **GET** /users/{user_id}/report-subscriptions | UsersReportSubscriptionsByUserId
*UsersApi* | [**postUsers**](docs/Api/UsersApi.md#postusers) | **POST** /users | Users
*UsersApi* | [**postUsersAccessPoliciesByUserId**](docs/Api/UsersApi.md#postusersaccesspoliciesbyuserid) | **POST** /users/{user_id}/access_policies | UsersAccessPoliciesByUserId
*UsersApi* | [**postUsersReportSubscriptionsByUserId**](docs/Api/UsersApi.md#postusersreportsubscriptionsbyuserid) | **POST** /users/{user_id}/report-subscriptions | UsersReportSubscriptionsByUserId
*UsersApi* | [**putUsersAccessPoliciesByUserId**](docs/Api/UsersApi.md#putusersaccesspoliciesbyuserid) | **PUT** /users/{user_id}/access_policies | UsersAccessPoliciesByUserId
*UsersApi* | [**putUsersByUserId**](docs/Api/UsersApi.md#putusersbyuserid) | **PUT** /users/{user_id} | UsersByUserId
*VersionsApi* | [**getVersions**](docs/Api/VersionsApi.md#getversions) | **GET** /versions | Versions
*WellApi* | [**getWellKnownCloudConfiguration**](docs/Api/WellApi.md#getwellknowncloudconfiguration) | **GET** /.well-known/cloud-configuration | WellKnownCloudConfiguration
*WellApi* | [**getWellKnownOpenIdConfiguration**](docs/Api/WellApi.md#getwellknownopenidconfiguration) | **GET** /.well-known/openid-configuration | WellKnownOpenIdConfiguration


## Documentation For Models

 - [AccessPoliciesList](docs/Model/AccessPolicies/AccessPoliciesList.md)
 - [AccessPolicy](docs/Model/AccessPolicies/AccessPolicy.md)
 - [AccessPolicyPost](docs/Model/AccessPolicies/AccessPolicyPost.md)
 - [AccessPolicyPostResource](docs/Model/AccessPolicies/AccessPolicyPostResource.md)
 - [AccessPolicyTrusteeType](docs/Model/AccessPolicies/AccessPolicyTrusteeType.md)
 - [Application](docs/Model/Applications/Application.md)
 - [BatchUsageList](docs/Model/Usages/BatchUsageList.md)
 - [BatchUsageListItems](docs/Model/Usages/BatchUsageListItems.md)
 - [BillingPeriods](docs/Model/Billing/BillingPeriods.md)
 - [BillingPeriodsItems](docs/Model/Billing/BillingPeriodsItems.md)
 - [BillingPeriodsOfferingItem](docs/Model/Billing/BillingPeriodsOfferingItem.md)
 - [BillingPeriodsPut](docs/Model/Billing/BillingPeriodsPut.md)
 - [BillingPeriodsPutItems](docs/Model/Billing/BillingPeriodsPutItems.md)
 - [BillingPeriodsPutOfferingItem](docs/Model/Billing/BillingPeriodsPutOfferingItem.md)
 - [BillingTenantSettings](docs/Model/Billing/BillingTenantSettings.md)
 - [BillingTenantSettingsMode](docs/Model/Billing/BillingTenantSettingsMode.md)
 - [BillingTenantSettingsPut](docs/Model/Billing/BillingTenantSettingsPut.md)
 - [BillingTenantSettingsPutMode](docs/Model/Billing/BillingTenantSettingsPutMode.md)
 - [BillingTenantSettingsPutUsageCalculationMode](docs/Model/Billing/BillingTenantSettingsPutUsageCalculationMode.md)
 - [BillingTenantSettingsUsageCalculationMode](docs/Model/Billing/BillingTenantSettingsUsageCalculationMode.md)
 - [BusinessType](docs/Model/Common/Types/BusinessType.md)
 - [Client](docs/Model/Clients/Client.md)
 - [ClientPost](docs/Model/Clients/ClientPost.md)
 - [ClientPut](docs/Model/Clients/ClientPut.md)
 - [CloudConfiguration](docs/Model/CloudConfiguration/CloudConfiguration.md)
 - [CloudConfigurationItems](docs/Model/CloudConfiguration/CloudConfigurationItems.md)
 - [Contact](docs/Model/Common/Contact/Contact.md)
 - [Details](docs/Model/Ad/Details.md)
 - [EffectiveBrand](docs/Model/Tenants/EffectiveBrand.md)
 - [Error](docs/Model/Common/Error.md)
 - [Error30](docs/Model/Common/Error30.md)
 - [ErrorDetails](docs/Model/Common/ErrorDetails.md)
 - [ErrorError](docs/Model/Common/ErrorError.md)
 - [GrantTypeenum](docs/Model/GrantTypeenum.md)
 - [Identity](docs/Model/Idp/Identity.md)
 - [IdentityPost](docs/Model/Idp/IdentityPost.md)
 - [IdentityPut](docs/Model/Idp/IdentityPut.md)
 - [Infra](docs/Model/Infra/Infra.md)
 - [InfraBatch](docs/Model/Infra/InfraBatch.md)
 - [InfraCap](docs/Model/Infra/InfraCap.md)
 - [InfraList](docs/Model/Infra/InfraList.md)
 - [InfraPost](docs/Model/Infra/InfraPost.md)
 - [InfraPut](docs/Model/Infra/InfraPut.md)
 - [Jwks](docs/Model/Idp/Jwks.md)
 - [JwksItems](docs/Model/Idp/JwksItems.md)
 - [ModelList](docs/Model/Common/ModelList.md)
 - [OfferingItem](docs/Model/Tenants/OfferingItem.md)
 - [OfferingItemList](docs/Model/OfferingItems/OfferingItemList.md)
 - [OfferingItemOutput](docs/Model/OfferingItems/OfferingItemOutput.md)
 - [OfferingItemsPut](docs/Model/Tenants/OfferingItemsPut.md)
 - [OpenIdConfiguration](docs/Model/OpenIdConfiguration/OpenIdConfiguration.md)
 - [PasswordPost](docs/Model/Idp/PasswordPost.md)
 - [PasswordPut](docs/Model/Idp/PasswordPut.md)
 - [Quota](docs/Model/OfferingItems/Quota.md)
 - [Report](docs/Model/Reports/Report.md)
 - [ReportKind](docs/Model/Reports/ReportKind.md)
 - [ReportLevel](docs/Model/Reports/ReportLevel.md)
 - [ReportParameters](docs/Model/Reports/ReportParameters.md)
 - [ReportPeriod](docs/Model/Reports/ReportPeriod.md)
 - [ReportPost](docs/Model/Reports/ReportPost.md)
 - [ReportPostKind](docs/Model/Reports/ReportPostKind.md)
 - [ReportPostLevel](docs/Model/Reports/ReportPostLevel.md)
 - [ReportPostParameters](docs/Model/Reports/ReportPostParameters.md)
 - [ReportPostPeriod](docs/Model/Reports/ReportPostPeriod.md)
 - [ReportPostSchedule](docs/Model/Reports/ReportPostSchedule.md)
 - [ReportPostType](docs/Model/Reports/ReportPostType.md)
 - [ReportPut](docs/Model/Reports/ReportPut.md)
 - [ReportPutKind](docs/Model/Reports/ReportPutKind.md)
 - [ReportPutLevel](docs/Model/Reports/ReportPutLevel.md)
 - [ReportPutParameters](docs/Model/Reports/ReportPutParameters.md)
 - [ReportPutSchedule](docs/Model/Reports/ReportPutSchedule.md)
 - [ReportSchedule](docs/Model/Reports/ReportSchedule.md)
 - [ReportSubscriptionPost](docs/Model/Reports/ReportSubscriptionPost.md)
 - [ReportType](docs/Model/Reports/ReportType.md)
 - [ResourceServer](docs/Model/ResourceServers/ResourceServer.md)
 - [Role](docs/Model/Common/Types/Role.md)
 - [Role](docs/Model/Roles/Role.md)
 - [RoleList](docs/Model/Applications/RoleList.md)
 - [RoleListItems](docs/Model/Applications/RoleListItems.md)
 - [RolePost](docs/Model/Roles/RolePost.md)
 - [RolePostItems](docs/Model/Roles/RolePostItems.md)
 - [RolePut](docs/Model/Roles/RolePut.md)
 - [RolePutItems](docs/Model/Roles/RolePutItems.md)
 - [Scope](docs/Model/ResourceServers/Scope.md)
 - [Search](docs/Model/Ad/Search.md)
 - [Search](docs/Model/Tenants/Search.md)
 - [SearchItems](docs/Model/Ad/SearchItems.md)
 - [SearchItems](docs/Model/Tenants/SearchItems.md)
 - [SearchType](docs/Model/Ad/SearchType.md)
 - [Sessions200](docs/Model/Idp/Sessions200.md)
 - [Sessions200Items](docs/Model/Idp/Sessions200Items.md)
 - [Setting](docs/Model/Settings/Setting.md)
 - [SettingEffective](docs/Model/Settings/SettingEffective.md)
 - [SettingList](docs/Model/Settings/SettingList.md)
 - [SettingOwn](docs/Model/Settings/SettingOwn.md)
 - [SettingOwner](docs/Model/Settings/SettingOwner.md)
 - [SettingPut](docs/Model/Settings/SettingPut.md)
 - [SettingSchema](docs/Model/Settings/SettingSchema.md)
 - [SettingSchemaBusinessType](docs/Model/Settings/SettingSchemaBusinessType.md)
 - [SettingSchemaInheritanceType](docs/Model/Settings/SettingSchemaInheritanceType.md)
 - [SettingSchemaList](docs/Model/Settings/SettingSchemaList.md)
 - [SettingType](docs/Model/Settings/SettingType.md)
 - [Tenant](docs/Model/Tenants/Tenant.md)
 - [TenantBatch](docs/Model/Tenants/TenantBatch.md)
 - [TenantPost](docs/Model/Tenants/TenantPost.md)
 - [TenantPut](docs/Model/Tenants/TenantPut.md)
 - [Token](docs/Model/Idp/Token.md)
 - [Token400](docs/Model/Idp/Token400.md)
 - [Token400522](docs/Model/Idp/Token400522.md)
 - [TrusteeTypeItemEnum](docs/Model/TrusteeTypeItemEnum.md)
 - [UsageList](docs/Model/Usages/UsageList.md)
 - [UsageOutput](docs/Model/Usages/UsageOutput.md)
 - [UsageOutputOfferingItem](docs/Model/Usages/UsageOutputOfferingItem.md)
 - [User](docs/Model/Users/User.md)
 - [UserBatch](docs/Model/Users/UserBatch.md)
 - [UserChangeEmailPost](docs/Model/Users/UserChangeEmailPost.md)
 - [UserGroup](docs/Model/UserGroups/UserGroup.md)
 - [UserGroupPost](docs/Model/UserGroups/UserGroupPost.md)
 - [UserGroupPut](docs/Model/UserGroups/UserGroupPut.md)
 - [UserPost](docs/Model/Users/UserPost.md)
 - [UserPut](docs/Model/Users/UserPut.md)
 - [Version](docs/Model/Version/Version.md)
 - [VersionApplication](docs/Model/Version/VersionApplication.md)
 - [VersionComponent](docs/Model/Version/VersionComponent.md)


## Documentation For Authorization


## auth

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: host/api/2/idp/authorize
- **Scopes**: N/A


## Author




