# Acronis\Cloud\Client\LegalDocumentsApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteLegalDocumentsByLegalDocumentId**](LegalDocumentsApi.md#deleteLegalDocumentsByLegalDocumentId) | **DELETE** /legal_documents/{legal_document_id} | LegalDocumentsByLegalDocumentId
[**getLegalDocuments**](LegalDocumentsApi.md#getLegalDocuments) | **GET** /legal_documents | LegalDocuments
[**getLegalDocumentsByLegalDocumentId**](LegalDocumentsApi.md#getLegalDocumentsByLegalDocumentId) | **GET** /legal_documents/{legal_document_id} | LegalDocumentsByLegalDocumentId
[**putLegalDocumentsByLegalDocumentId**](LegalDocumentsApi.md#putLegalDocumentsByLegalDocumentId) | **PUT** /legal_documents/{legal_document_id} | LegalDocumentsByLegalDocumentId


# **deleteLegalDocumentsByLegalDocumentId**
> deleteLegalDocumentsByLegalDocumentId($legal_document_id, $version)

LegalDocumentsByLegalDocumentId

Delete given legal document. You cannot delete already published legal document

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LegalDocumentsApi();
$legal_document_id = "legal_document_id_example"; // string | 
$version = 789; // int | Growing number of legal document internal version

try {
    $api_instance->deleteLegalDocumentsByLegalDocumentId($legal_document_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling LegalDocumentsApi->deleteLegalDocumentsByLegalDocumentId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **legal_document_id** | **string**|  |
 **version** | **int**| Growing number of legal document internal version |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getLegalDocuments**
> \Acronis\Cloud\Client\Model\LegalDocument\LegalDocumentBatch getLegalDocuments($uuids)

LegalDocuments

Get legal documents batch

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LegalDocumentsApi();
$uuids = "uuids_example"; // string | Return information for legal documents with specified UUIDS

try {
    $result = $api_instance->getLegalDocuments($uuids);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LegalDocumentsApi->getLegalDocuments: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuids** | **string**| Return information for legal documents with specified UUIDS |

### Return type

[**\Acronis\Cloud\Client\Model\LegalDocument\LegalDocumentBatch**](../Model/LegalDocument/LegalDocumentBatch.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getLegalDocumentsByLegalDocumentId**
> \Acronis\Cloud\Client\Model\LegalDocument\LegalDocument getLegalDocumentsByLegalDocumentId($legal_document_id)

LegalDocumentsByLegalDocumentId

Get full information about given legal document

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LegalDocumentsApi();
$legal_document_id = "legal_document_id_example"; // string | 

try {
    $result = $api_instance->getLegalDocumentsByLegalDocumentId($legal_document_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LegalDocumentsApi->getLegalDocumentsByLegalDocumentId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **legal_document_id** | **string**|  |

### Return type

[**\Acronis\Cloud\Client\Model\LegalDocument\LegalDocument**](../Model/LegalDocument/LegalDocument.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putLegalDocumentsByLegalDocumentId**
> \Acronis\Cloud\Client\Model\LegalDocument\LegalDocument putLegalDocumentsByLegalDocumentId($legal_document_id, $version, $body)

LegalDocumentsByLegalDocumentId

Update information about given legal document. You cannot update already published legal document

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LegalDocumentsApi();
$legal_document_id = "legal_document_id_example"; // string | 
$version = 789; // int | Growing number of legal document internal version
$body = new \Acronis\Cloud\Client\Model\LegalDocument\LegalDocumentPut(); // \Acronis\Cloud\Client\Model\LegalDocument\LegalDocumentPut | 

try {
    $result = $api_instance->putLegalDocumentsByLegalDocumentId($legal_document_id, $version, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LegalDocumentsApi->putLegalDocumentsByLegalDocumentId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **legal_document_id** | **string**|  |
 **version** | **int**| Growing number of legal document internal version |
 **body** | [**\Acronis\Cloud\Client\Model\LegalDocument\LegalDocumentPut**](../Model/LegalDocument/LegalDocumentPut.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\LegalDocument\LegalDocument**](../Model/LegalDocument/LegalDocument.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

